--INTEL DEVELOPER'S SOFTWARE LICENSE AGREEMENT

--BY USING THIS SOFTWARE, YOU ARE AGREEING TO BE BOUND 
--BY THE TERMS OF THIS AGREEMENT.  DO NOT USE THE SOFTWARE 
--UNTIL YOU HAVE CAREFULLY READ AND AGREED TO THE FOLLOWING 
--TERMS AND CONDITIONS.  IF YOU DO NOT AGREE TO THE TERMS 
--OF THIS AGREEMENT, PROMPTLY RETURN THE SOFTWARE PACKAGE 
--AND ANY ACCOMPANYING ITEMS.

--IF YOU USE THIS SOFTWARE, YOU WILL BE BOUND BY THE TERMS 
--OF THIS AGREEMENT.

--LICENSE:  Intel Corporation ("Intel") grants you 
--the non-exclusive right to use the enclosed software 
--program ("Software").  You will not use, copy, modify, 
--display, rent, sell or transfer the Software or any portion 
--thereof, except as provided in this Agreement.

--System OEM Developers may:
--1.      copy the Software for internal support, backup 
--        or archival purposes;
--2.      internally install, use, display, or distribute 
--        Intel owned Software in object code format;
--3.      internally modify Software source code that 
--        Intel makes available to you for internal use 
--        only as an OEM Developer;
--4.	internally install, use, display, modify, distribute, 
--        and/or make derivatives ("Derivatives") of Intel owned 
--        Software ONLY if you are a System OEM Developer and  
--        NOT an end-user.

--RESTRICTIONS:

--YOU WILL NOT:
--1.  	copy the Software, in whole or in part, except as 
--        provided for in this Agreement;
--2.      decompile or reverse engineer any Software provided 
--        in object code format;
--3.      distribute any Software or Derivative code to any 
--        end-users, unless approved by Intel in a prior writing.

--TRANSFER: You may not transfer the Software to any third 
--party without Intels prior written consent.

--OWNERSHIP AND COPYRIGHT OF SOFTWARE: Title to the Software 
--and all copies thereof remain with Intel or its vendors.  
--The Software is copyrighted and is protected by United States
--and international copyright laws.  You will not remove the 
--copyright notice from the Software.  You agree to prevent 
--any unauthorized copying of the Software.

--DERIVATIVE WORK: OEM Developers that make Derivatives will 
--not be required to provide Intel with a copy of the source 
--or object code.  Any modification of Software shall be at 
--your sole risk and expense. No Software or Derivative 
--distribution to any third party is permitted under this 
--Agreement.

--DUAL MEDIA SOFTWARE: If the Software package contains 
--multiple media, you may only use the medium appropriate 
--for your system.
 
--WARRANTY: Intel warrants that it has the right to license 
--you to use, modify, display, or distribute the Software as 
--provided in this Agreement. The Software is provided "AS IS" 
--without WARRANTY of any kind.  Intel makes no representations 
--to upgrade, maintain, or support the Software at any time.


--THE ABOVE WARRANTIES ARE THE ONLY WARRANTIES OF ANY  
--KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WARRANTIES 
--OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE 
--OR INFRINGEMENT OF ANY PATENT, COPYRIGHT OR OTHER 
--INTELLECTUAL PROPERTY RIGHT.

--LIMITATION OF LIABILITY: NEITHER INTEL NOR ITS 
--VENDORS OR AGENTS SHALL BE LIABLE FOR ANY LOSS 
--OF PROFITS, LOSS OF USE, LOSS OF DATA, INTERRUPTION 
--OF BUSINESS, NOR FOR INDIRECT, SPECIAL, INCIDENTAL 
--OR CONSEQUENTIAL DAMAGES OF ANY KIND WHETHER UNDER 
--THIS AGREEMENT OR OTHERWISE, EVEN IF ADVISED OF THE 
--POSSIBILITY OF SUCH DAMAGES.

--TERMINATION OF THIS LICENSE: Intel reserves the right 
--to conduct or have conducted audits to verify your 
--compliance with this Agreement.  Intel may terminate 
--this Agreement at any time if you are in breach of 
--any of its terms and conditions.  Upon termination, 
--you will immediately destroy, and certify in writing 
--the destruction of, the Software or return all copies 
--of the Software and documentation to Intel.

--U.S. GOVERNMENT RESTRICTED RIGHTS: The Software and 
--documentation were developed at private expense and 
--are provided with "RESTRICTED RIGHTS".  Use, duplication 
--or disclosure by the Government is subject to restrictions 
--as set forth in FAR52.227-14 and DFAR252.227-7013 et seq. 
--or its successor.

--EXPORT LAWS: You agree that the distribution and 
--export/re-export of the Software is in compliance 
--with the laws, regulations, orders or other restrictions 
--of the U.S. Export Administration Regulations.

--APPLICABLE LAW: This Agreement is governed by the 
--laws of the State of California and the United States, 
--including patent and copyright laws.  Any claim 
--arising out of this Agreement will be brought in 
--Santa Clara County, California.

--****************************************************************

-- File Name: 28f400b3.vhd

-- File Specifics

-- VHDL Code for 28F400B3 4 MBIT (256 X 16)
-- Top Boot Block Part

-- This is a fully fucntional model with all of the 
-- commands available to a 28F400B3 part.

--****************************************************************

--****************** Key Various Bit States **********************

-- Read Types

-- 00 = Read Array
-- 01 = Read ID
-- 10 = Read Status Register
-- 11 = Safe State

-- Write Types

-- 00 = Clear Status Register
-- 01 = Program
-- 10 = Block Erase
-- 11 = Safe State

--***************************************************************

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE WORK.type1_pkg.ALL;

ENTITY f400b3 IS

	GENERIC
	(
		Vcc		:IN	voltage := vcc_voltage;
		Vccq		:IN	voltage := vccq_voltage;
		Vpp		:IN	voltage := vpp_voltage
	);
	PORT
	(
		dq	:INOUT	STD_ULOGIC_VECTOR (15 downto 0);
		add	:IN	STD_ULOGIC_VECTOR (17 downto 0);
		oeb	:IN	BIT;
		ceb	:IN	BIT;
		web	:IN	BIT;
		rpb	:IN	BIT;
		wpb	:IN	BIT
	);

END f400b3;

ARCHITECTURE behavior OF f400b3 IS
		
        	SIGNAL clock	:BIT := '0';
		SIGNAL next_clock :BIT := '1';
		
		CONSTANT length	:INTEGER := 262143;
--		CONSTANT length :INTEGER := 65535;
		
		TYPE word IS ARRAY(15 DOWNTO 0) OF STD_ULOGIC;
		TYPE memarray IS ARRAY(0 TO length) OF word;
		TYPE IDregister IS ARRAY (0 TO 1) OF word;
BEGIN
	
	MAIN:PROCESS(next_clock)
	
	VARIABLE adder :INTEGER := 0;
	VARIABLE twosum :INTEGER := 1;
	VARIABLE t1 :TIME :=tELQV - tGLQV; 	--Holds contents of tELQV - tGLQV
	VARIABLE t2 :TIME := 0 ns;
	VARIABLE memory :memarray;
	VARIABLE IDreg :IDregister;
	VARIABLE statreg :STD_ULOGIC_VECTOR (7 downto 0) := "10000000";
	VARIABLE test :STD_ULOGIC_VECTOR (17 downto 0);
	VARIABLE test2 :STD_ULOGIC_VECTOR (17 downto 0);        
	VARIABLE read_type :STD_ULOGIC_VECTOR (1 downto 0) := "11";
	VARIABLE write_type :STD_ULOGIC_VECTOR (1 downto 0) := "11";
	VARIABLE prog_suspend :STD_ULOGIC_VECTOR (1 downto 0) := "11";
	VARIABLE new_state :INTEGER := 0;
	VARIABLE state:INTEGER;
	VARIABLE state_clock :BIT := '0';
	VARIABLE tempadd1 :STD_ULOGIC_VECTOR (17 downto 0);
	VARIABLE tempadd2 :STD_ULOGIC_VECTOR (17 downto 0);
	VARIABLE tempadd3 :STD_ULOGIC_VECTOR (17 downto 0);
	VARIABLE adder2 :INTEGER;
	VARIABLE summer :INTEGER := 0;
	VARIABLE loader :BIT:= '0';
	VARIABLE looper :INTEGER := 2;
	VARIABLE jump: INTEGER := 65536;
	VARIABLE prog :BIT := '0';
	VARIABLE blocker :STD_ULOGIC_VECTOR (3 downto 0);
	VARIABLE hold_data : STD_ULOGIC_VECTOR (15 downto 0);
	VARIABLE hold_add : STD_ULOGIC_VECTOR (17 downto 0);
	VARIABLE block_begin :STD_ULOGIC_VECTOR (17 downto 0) := "000000000000000000";
	VARIABLE block_end :STD_ULOGIC_VECTOR (17 downto 0) := "000000000000000000";
	VARIABLE get_address :STD_ULOGIC_VECTOR (17 downto 0) := "000000000000000000";
	VARIABLE holder :BIT := '0';
	VARIABLE holder2 :BIT := '0';
	VARIABLE reader :BIT := '0';
	VARIABLE grabber :BIT := '0';
	VARIABLE quitter :BIT := '0';
	VARIABLE eraser :BIT := '0';
	VARIABLE block_prog :BIT := '0';
	VARIABLE go :BIT := '0';
        VARIABLE place_holder :BIT := '0';
	VARIABLE decode: STD_ULOGIC_VECTOR (15 downto 0);
	VARIABLE write_time :STD_ULOGIC_VECTOR (2 downto 0) := "111";
	VARIABLE delay :TIME := 0 ns;
	VARIABLE timer1 :TIME := 0 ns;
	VARIABLE timer2 :TIME := 0 ns;
	VARIABLE timer3 :TIME := 0 ns;
	VARIABLE tempdata : STD_ULOGIC_VECTOR (15 downto 0);
	VARIABLE first_pass :BIT := '0';
	VARIABLE interupt :INTEGER := 100;  -- Equivalent Value of tWHQV1-3 for simulation
	VARIABLE counter1 :INTEGER := 0;
	VARIABLE counter2 :INTEGER := 0;
	VARIABLE interupt_check1 :BIT := '1';
	VARIABLE interupt_check2 :BIT := '1';

	BEGIN
-- This section intializes the memory array which contains
-- all 1's.

	IF (loader = '0') THEN
		FOR i IN 0 TO length LOOP
			memory(i) := "1111111111111111";
		END LOOP;

-- This section intializes the ID Register which contains
-- Device & Manufacturer ID


		IDreg(0) := "0000000010001001";  -- Manufacturer ID: 0089h
		IDreg(1) := "1000100010010000";  -- Device ID: 8890h for Top Boot Device
	
		loader := '1';
	END IF;
        
	CASE new_state IS

	WHEN 0 =>			-- Powerup State
		state := 0;
		statreg := "10000000";
		dq <= "ZZZZZZZZZZZZZZZZ";
		grabber := '0';
		prog := '0';
		block_prog := '0';
		IF (ceb = '0') THEN
			new_state := 1;		--Goes to ceb_low.
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 0;		--Stays in Powerup;
		END IF;
		
	 	state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 1 =>			-- CE# Low State
		state := 1;
		IF (oeb = '0') THEN
			first_pass := '1';
			new_state := 5;		--Goes to oeb_low
	    	ELSIF (web = '0') THEN
			ASSERT (ceb'LAST_EVENT >= tELWL)
			REPORT "Setup violation of tELWL."
			SEVERITY ERROR;
			timer1 := NOW;			
			new_state := 3;		--Goes to web_low
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 1;		--Stays in ceb_low 
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 3 =>			-- WE# Low State
		state := 3;
		read_type := "11";
		
		IF (web = '0') AND (grabber = '1') THEN
			hold_data := dq;
			hold_add  := add;
			grabber := '0';
		END IF;
		IF (web = '0') AND (eraser = '1') THEN
			IF (dq = "0000000011010000") THEN
				IF ((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV))
				OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV)) THEN
					hold_add := add;
					eraser := '0';
				ELSE
					statreg(3) := '1';
					eraser := '0';
					block_prog := '0';
				END IF;
			ELSE
				eraser := '0';
				block_prog:= '0';
				statreg(5) := '1';
			END IF;
		END IF;
		IF (web = '1') THEN
			timer2:= NOW;
			timer3:= timer2 - timer1;
			ASSERT (timer3 >= tWLWH)
			REPORT "WE# Pulse Width Error."
			SEVERITY ERROR;
			ASSERT (dq'LAST_EVENT >= tDVWH)
			REPORT "Data Setup Time Violation."
			SEVERITY ERROR;
			decode := dq;
			new_state := 4;
		ELSIF (ceb = '1') THEN
			timer2 := NOW;
			timer3 := timer1 - timer2;
			ASSERT (timer3 >= tELEH)
			REPORT "CE# Pulse Width Error."
			SEVERITY ERROR;
			ASSERT (dq'LAST_EVENT >= tDVEH)
			REPORT "Data Setup Time Violation."
			SEVERITY ERROR;
			decode := dq;
			new_state := 4;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			decode := dq;
			new_state := 3;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 4 =>			-- Write Command State
		state := 4;
		IF (web = '1') THEN
			ASSERT (dq'LAST_EVENT >= tWHDX)
			REPORT "Data Hold Time Violation."
			SEVERITY ERROR;
			IF (prog = '1') THEN
				new_state := 14;
			ELSIF (block_prog = '1') THEN
				new_state := 12;
			ELSIF (decode = "0000000011111111") OR (read_type = "00") THEN	-- FFh
				IF (read_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "00";	-- Read Array Type
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000001110000") OR (read_type = "10") THEN	-- 70h
				IF (read_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "10";	-- Read S.R. Type
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000010010000") OR (read_type = "01") THEN	-- 90h
				IF (read_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "01";	-- Read ID State
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000001010000") THEN	-- 50h
				write_type := "00";	-- Clear Status SR
				IF (ceb = '0') THEN
					new_state := 7;
				ELSE
					new_state := 4;
				END IF;
			ELSIF (decode = "0000000000010000") 
			OR (decode = "0000000001000000") THEN	-- 10h OR 40h
				write_type := "01";	-- Program	
				ASSERT (add'LAST_EVENT >= tAVWH)
				REPORT "Address Setup Time Violation."		
				SEVERITY ERROR;
				prog := '1';
				grabber := '1';
				interupt_check1 := '0';
				IF (web = '1') THEN
					new_state := 1;	-- CE# Low State
				ELSIF (ceb = '1') THEN
					new_state := 6;	-- CE# High State
				ELSE
					new_state := 4;	-- Write Command State
				END IF;
			ELSIF (decode = "0000000000100000") THEN	-- 20h
				write_type := "10";	-- Block Erase
				eraser := '1';
				block_prog := '1';
				interupt_check2 := '0';
				ASSERT (add'LAST_EVENT >= tAVWH)
				REPORT "Address Setup Time Violation."				
				SEVERITY ERROR;
				IF (web = '1') THEN
					new_state := 1;	-- CE# Low State
				ELSIF (ceb = '1') THEN
					new_state := 6;	-- CE# High State
				ELSE
					new_state := 4;	-- Write Command State
				END IF;
			ELSIF (decode = "0000000010110000") THEN	-- B0h
				IF (prog_suspend = "00") THEN
					new_state := 9;		-- Program Suspend
				ELSIF (prog_suspend = "01") THEN
					new_state := 11;	-- Erase Suspend
				END IF;
			ELSE
				new_state := 5;
			END IF;
		ELSIF (ceb = '1') THEN
			ASSERT (dq'LAST_EVENT >= tEHDX)
			REPORT "Data Hold Time Violation."
			SEVERITY ERROR;
			IF (prog = '1') OR (block_prog = '1') THEN
				new_state := 7;
			ELSIF (decode = "0000000011111111") OR (read_type = "00")THEN	-- FFh
				IF (write_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "00";	-- Read Array Type
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000001110000") OR (read_type ="10") THEN	-- 70h
				IF (write_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "10";	-- Read S.R. Type
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000010010000") OR (read_type = "01") THEN	-- 90h
				IF (write_type = "11") THEN
					first_pass := '1';
				END IF;
				read_type := "01";	-- Read ID State
				IF (oeb = '0') AND (ceb = '0') THEN
				 	ASSERT (ceb'LAST_EVENT >= tELOL)
				 	REPORT "CE# Setup To OE# Going Low Violation."
				 	SEVERITY ERROR;
					new_state := 5;		-- Read State
				ELSE 
					new_state := 4;	
				END IF;
			ELSIF (decode = "0000000001010000") THEN	-- 50h
				write_type := "00";	-- Clear Status SR
				IF (ceb = '0') THEN
					new_state := 7;
				ELSE
					new_state := 4;
				END IF;
			ELSIF (decode = "0000000000010000") 
			OR (decode = "0000000001000000") THEN	-- 10h OR 40h
				write_type := "01";		-- Program Mode
				grabber := '1';
				interupt_check1 := '0';
			  	ASSERT (add'LAST_EVENT >= tAVWH)
			  	REPORT "Address Setup Time Violation."				
			  	SEVERITY ERROR;
				prog := '1';
				IF (web = '1') THEN
					new_state := 1;	-- CE# Low State
				ELSIF (ceb = '1') THEN
					new_state := 6;	-- CE# High State
				ELSE
					new_state := 4;	-- Write Command State
				END IF;
			ELSIF (decode = "0000000000100000") THEN	-- 20h
				write_type := "10";	-- Block Erase
				eraser := '1';
				block_prog := '1';
				interupt_check2 := '0';
				ASSERT (add'LAST_EVENT >= tAVWH)
				REPORT "Address Setup Time Violation."				
				SEVERITY ERROR;
				IF (web = '1') THEN
					new_state := 1;	-- CE# Low State
				ELSIF (ceb = '1') THEN
					new_state := 6;	-- CE# High State
				ELSE
					new_state := 4;	-- Write Command State
				END IF;
			ELSIF (decode = "0000000010110000") THEN	-- B0h
				IF (prog_suspend = "00") THEN
					new_state := 9;		-- Program Suspend
				ELSIF (prog_suspend = "01") THEN
					new_state := 11;	-- Erase Suspend
				END IF;
			ELSE
				new_state := 5;
			END IF;
		ELSIF (rpb = '0') THEN
			new_state := 10;		--Goes to Powerdown
		ELSIF (web = '0') THEN			--WE# low state
			timer1 := NOW;
			new_state := 3;
		ELSIF (oeb = '0') AND (web = '1') AND (ceb = '0') THEN
			first_pass := '1';
			new_state := 5;
		ELSE
			new_state := 4;
		END IF;
		
                state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 5 =>					-- Read State
		state := 5;

		IF (first_pass = '1') THEN
			ASSERT (add'LAST_EVENT >= tAVWH) 
       			REPORT "Address Setup Error."
       			SEVERITY ERROR;
			first_pass := '0';
		END IF;

		IF (read_type = "00") THEN		-- Read Array
			adder := 0;
			twosum := 1;
			FOR i IN 0 TO add'LENGTH - 1 LOOP
				IF (add(i) = '1') THEN
					adder := adder + twosum;
				END IF;
				twosum := twosum * 2;
			END LOOP;
			FOR j IN 0 TO memory(adder)'LENGTH - 1 LOOP
				tempdata(j) := memory(adder) (j);
			END LOOP;
			dq <= tempdata AFTER tGLQV;
			read_type := "00";
			new_state := 4;
		ELSIF (read_type = "01") THEN			-- Read ID
			IF (add = "00000000000000000000") THEN	-- Manufacturer's ID
				FOR j IN 0 TO IDreg(0)'LENGTH - 1 LOOP
					tempdata(j) := IDreg(0) (j);
				END LOOP;
				dq <= tempdata AFTER tGLQV;
				new_state := 4;
			ELSIF (add = "00000000000000000001") THEN	-- Device ID for Top Boot
				FOR j IN 0 TO IDreg(1)'LENGTH - 1 LOOP
					tempdata(j) := IDreg(1) (j);
				END LOOP;
				dq <= tempdata AFTER tGLQV;
				new_state := 4;
			ELSE
				read_type := "11";
				new_state := 4;
			END IF;
		ELSIF (read_type = "10") THEN		-- Read Status Register
			FOR j IN 0 TO statreg'LENGTH - 1 LOOP
				tempdata(j) := statreg(j);
			END LOOP;
			FOR j IN 8 TO dq'LENGTH -1 LOOP
				tempdata(j) := '0';
			END LOOP;
			dq <= tempdata AFTER tGLQV;
			new_state := 4;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSIF (oeb = '1') AND (ceb = '0') THEN
			read_type := "11";
			new_state := 1;
		ELSIF (ceb = '1') THEN
			read_type := "11";
			new_state := 6;		-- Goes to CE# High State
		ELSE
			new_state := 5;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock AFTER delay;

	WHEN 6 =>			-- CE# High State
		state := 6;
		dq <= "ZZZZZZZZZZZZZZZZ";
		
		IF (ceb = '0') AND (holder = '0') THEN
			new_state := 1;
		ELSIF (ceb = '0') AND (holder = '1') THEN
			holder := '0';
			new_state := 9;
		ELSIF (ceb = '0') AND (holder2 = '1') THEN
			holder2 := '0';
			new_state := 11;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 6;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 7 =>			-- Write to Memory/SR State
		state := 7;
		statreg(7) := '0';
		statreg(2) := '0';	-- This is what I added!!!!!

		IF (write_type = "00") THEN 	-- Clear SR
                	statreg(5) := '0';
			statreg(4) := '0';
			statreg(3) := '0';
			statreg(1) := '0';
			statreg(7) := '1';
			write_type := "11";
			write_time := "000";
			new_state := 4;
		END IF;
		
		IF (write_type = "01") THEN  -- Program Mode
			adder := 0;
		      	twosum := 1;
		      	FOR i IN 0 TO hold_add'LENGTH - 1 LOOP
				IF (hold_add(i) = '1') THEN
				     	adder := adder + twosum;
			       	END IF;
			       	twosum := twosum * 2;
			END LOOP;
			IF (adder >= 1040384) AND (adder <= 1048575) THEN
				IF (wpb = '1') AND (rpb = '0') AND
				(((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
				OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV)))THEN
					IF (memory(adder) = "1111111111111111") THEN
						FOR j IN 0 TO hold_data'LENGTH - 1 LOOP
							memory(adder) (j) := hold_data(j);
						END LOOP;
						write_type := "11";
						prog := '0';
						grabber := '0';
					  	write_time := "001";
						interupt_check1 := '0';
						new_state := 8;
					ELSE
						FOR j IN 0 TO memory(adder)'LENGTH - 1 LOOP
							IF (hold_data(j) > memory(adder) (j)) THEN
							statreg(4) := '1';
							END IF;
						END LOOP;
						IF (statreg(4) = '0') THEN
							FOR j IN 0 TO hold_data'LENGTH - 1 LOOP
								memory(adder) (j) := hold_data(j);
							END LOOP;
						END IF;
						write_type := "11";
						prog := '0';
						grabber := '0';
						write_time := "001";
						interupt_check1 := '0';
						new_state := 8;
					END IF;
				ELSE
					statreg(4) := '1';
					statreg(1) := '1';
					statreg(7) := '1';
					write_type := "11";
					grabber := '0';
					write_time := "000";
					interupt_check1 := '0';
					new_state := 8;
				END IF;
			ELSIF (memory(adder) = "1111111111111111") AND 
			(((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
			OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV))) THEN
				FOR j IN 0 TO hold_data'LENGTH - 1 LOOP
					memory(adder) (j) := hold_data(j);
				END LOOP;
				write_type := "11";
				prog := '0';
				grabber := '0';
				write_time := "001";
				interupt_check1 := '0';
				new_state := 8;
			ELSE
				FOR j IN 0 TO memory(adder)'LENGTH - 1 LOOP
					IF (hold_data(j) > memory(adder) (j)) THEN
						statreg(4) := '1';
					END IF;
				END LOOP;
				IF (statreg(4) = '0') THEN
					FOR j IN 0 TO hold_data'LENGTH - 1 LOOP
						memory(adder) (j) := hold_data(j);
					END LOOP;
				END IF;
				write_type := "11";
				prog := '0';
				grabber := '0';
				write_time := "001";
				interupt_check1 := '0';
				new_state := 8;
			END IF;
		ELSIF (write_type = "10") THEN	-- Block Erase Mode
			tempadd3 := hold_add;
			tempadd3 := (tempadd3 AND "11110000000000000000");
			IF (tempadd3 >= "11111000000000000000") THEN
				IF (tempadd3 >= "11111110000000000000") 
				AND (tempadd3 <= "11111111111111111111") AND
				(((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
				OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV))) THEN
					IF (wpb = '1') THEN
						block_begin := (hold_add AND "11111111000000000000");
						block_end := (hold_add OR "00000000111111111111");
						adder := 0;
		      				twosum := 1;
		      				FOR i IN 0 TO block_begin'LENGTH - 1 LOOP
							IF (block_begin(i) = '1') THEN
			     					adder := adder + twosum;
							END IF;
			       			twosum := twosum * 2;
						END LOOP;
						summer := 0;
		      				twosum := 1;
		      				FOR i IN 0 TO block_end'LENGTH - 1 LOOP
							IF (block_end(i) = '1') THEN
				     				summer := summer + twosum;
			       				END IF;
			       			twosum := twosum * 2;
						END LOOP;
						FOR j IN adder TO summer LOOP
						memory(j) := "1111111111111111";
						END LOOP;
						block_prog := '0';
						write_time := "011";
						interupt_check2 := '0';
						new_state := 8;
					ELSE
						statreg(5) := '1';
						block_prog := '0';
						write_time := "000";
						interupt_check2 := '0';
						new_state := 8;
					END IF;
				ELSIF (((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
				OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV))) THEN
					block_begin := (hold_add AND "11111111000000000000");
					block_end := (hold_add OR "00000000111111111111");
					adder := 0;
		      			twosum := 1;
		      			FOR i IN 0 TO block_begin'LENGTH - 1 LOOP
						IF (block_begin(i) = '1') THEN
			     				adder := adder + twosum;
						END IF;
			       		twosum := twosum * 2;
					END LOOP;
					summer := 0;
		      			twosum := 1;
		      			FOR i IN 0 TO block_end'LENGTH - 1 LOOP
						IF (block_end(i) = '1') THEN
				     			summer := summer + twosum;
			       			END IF;
			       		twosum := twosum * 2;
					END LOOP;
					FOR j IN adder TO summer LOOP
					memory(j) := "1111111111111111";
					END LOOP;
					block_prog := '0';
					write_time := "010";
					interupt_check2 := '0';
					new_state := 8;
				END IF;
			ELSIF (hold_add(15) = '0') AND (((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
			OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV))) THEN
				block_begin := tempadd3;
				block_end := (tempadd3 OR "00000111111111111111");
				adder := 0;
		      		twosum := 1;
		      		FOR i IN 0 TO block_begin'LENGTH - 1 LOOP
					IF (block_begin(i) = '1') THEN
			     			adder := adder + twosum;
					END IF;
			       	twosum := twosum * 2;
				END LOOP;
				summer := 0;
		      		twosum := 1;
		      		FOR i IN 0 TO block_end'LENGTH - 1 LOOP
					IF (block_end(i) = '1') THEN
				     		summer := summer + twosum;
			       		END IF;
			       	twosum := twosum * 2;
				END LOOP;
				FOR j IN adder TO summer LOOP
					memory(j) := "1111111111111111";
				END LOOP;
				block_prog := '0';
				write_time := "010";
				interupt_check2 := '0';
				new_state := 8;
			ELSIF (((Vpp >= 2700000 uV) AND (Vpp <= 3600000 uV)) 
			OR ((Vpp >= 11400000 uV) AND (Vpp <= 12600000 uV))) THEN
				block_begin := (tempadd3 AND "00001000000000000000");
				block_end := (tempadd3 OR "00001111111111111111");
				adder := 0;
		      		twosum := 1;
		      		FOR i IN 0 TO block_begin'LENGTH - 1 LOOP
					IF (block_begin(i) = '1') THEN
			     			adder := adder + twosum;
					END IF;
				twosum := twosum * 2;
				END LOOP;
				summer := 0;
		      		twosum := 1;
		      		FOR i IN 0 TO block_end'LENGTH - 1 LOOP
					IF (hold_add(i) = '1') THEN
				     		summer := summer + twosum;
			       		END IF;
			       	twosum := twosum * 2;
				END LOOP;
				FOR j IN adder TO summer LOOP
					memory(j) := "1111111111111111";
				END LOOP;
				block_prog := '0';
				write_time := "010";
				interupt_check2 := '0';
				new_state := 8;
			END IF;
		ELSIF (rpb = '0') THEN
			new_state := 10;
		END IF;

		IF (write_time = "001") THEN
			delay := tWHQV1;
		ELSIF (write_time = "010") THEN
	 		delay :=  tWHQV3;
		ELSIF (write_time = "011") THEN
	 		delay := tWHQV2;
		ELSE
			delay := 0.5 ns;
		END IF;
		
		write_time := "111";

		state_clock := NOT state_clock;
	 	clock <= state_clock AFTER delay;

	WHEN 8 =>			-- Dummy Wait State
		state := 8;
		statreg(7) := '1';
		IF (ceb = '1') THEN
			new_state := 8;
		ELSIF (oeb = '1') AND (ceb = '0') AND (web = '1') THEN
			IF (go = '1') THEN
				go := '0';
				new_state := 12;
			ELSE
				dq <= "ZZZZZZZZZZZZZZZZ";
				new_state := 8;
			END IF;
		ELSIF (oeb = '0') AND (ceb = '0')THEN		-- Output Status Register
			FOR j IN 0 TO statreg'LENGTH - 1 LOOP
				dq(j) <= statreg(j);
			END LOOP;
			FOR j IN 8 TO dq'LENGTH -1 LOOP
				dq(j) <= '0';
			END LOOP;
			new_state := 8;
		ELSIF (web = '0') AND (ceb = '0') THEN
			IF (dq = "0000000011111111") OR (dq = "0000000001110000")
			OR (dq = "0000000010010000") OR (dq = "0000000001010000")
			OR (dq = "0000000000010000") OR (dq = "0000000001000000")
			OR (dq = "0000000000100000")  THEN
				IF (statreg(7) = '1') THEN
					new_state := 4;
				ELSE
					new_state := 8;
				END IF;
			ELSIF (dq = "0000000011010000") AND (place_holder = '1') THEN
				IF (statreg(7) = '1') THEN
					go := '1';
					write_type := "10";
					prog_suspend := "01";
					new_state := 8;
				ELSE
					new_state := 8;
				END IF;
			ELSE
				new_state := 8;
			END IF;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 8;
		END IF;

		state_clock := NOT state_clock;
		clock <= state_clock after 0.5 ns;
		
	WHEN 9 =>
		state := 9;
		statreg(2) := '1';

	     	IF (web = '1') AND (reader = '0') AND (quitter = '0') AND (oeb = '1') THEN
			ASSERT (dq'LAST_EVENT >= tWHDX)
			REPORT "Data Hold Time Violation."
			SEVERITY ERROR;
		    	new_state := 9;
		ELSIF (web = '1') AND (reader = '1') 
		AND (oeb = '0') AND (quitter = '0') THEN
			ASSERT (dq'LAST_EVENT >= tWHDX)
			REPORT "Data Hold Time Violation."
			SEVERITY ERROR;
			adder := 0;
			twosum := 1;
			FOR i IN 0 TO get_address'LENGTH - 1 LOOP
				IF (get_address(i) = '1') THEN
			       		adder := adder + twosum;
		       		END IF;
			       	twosum := twosum * 2;
			END LOOP;
		 	FOR j IN 0 TO memory(adder)'LENGTH - 1 LOOP
		 		tempdata(j) := memory(adder) (j);
		 	END LOOP;
			dq <= tempdata AFTER tGLQV;
			new_state := 9;
		ELSIF (web = '1') AND (quitter = '1') AND (reader = '0')THEN
			quitter := '0';
			prog := '1';
			prog_suspend := "11";
			new_state := 14;
		ELSIF (ceb = '1') THEN
			holder := '1';
			new_state := 6;
		ELSIF (oeb = '0') AND (ceb = '0') AND (web = '1') THEN	-- Output Status Register
			FOR j IN 0 TO statreg'LENGTH - 1 LOOP
				tempdata(j) := statreg(j);
			END LOOP;
			FOR j IN 8 TO dq'LENGTH -1 LOOP
				tempdata(j) := '0';
			END LOOP;
			dq <= tempdata AFTER tGLQV;
			new_state := 9;
		ELSIF (web = '0') AND (oeb = '1') THEN
			IF (dq = "0000000011111111") THEN	-- FFh
				reader := '1';
				get_address := add;
				new_state := 9;
			ELSIF (dq = "0000000011010000") THEN	-- D0h
				reader := '0';
				quitter := '1';
				new_state := 9;
			ELSIF (dq = "0000000001110000") THEN	-- 70h
				new_state := 9;
			ELSE
				ASSERT ((dq = "0000000011111111") OR (dq = "0000000011010000"))
				REPORT "Invalid Command Code!"
				SEVERITY ERROR;
				new_state := 9;
			END IF;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 9;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 10 =>
		state := 10;
		IF (rpb = '0') THEN
			new_state := 0;
		ELSE
			new_state := 10;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 11 =>
		state := 11;
		statreg(2) := '1';

	     	IF (web = '1') AND (reader = '0') AND (quitter = '0') AND (oeb = '1') THEN
		    	new_state := 11;
		ELSIF (web = '1') AND (quitter = '1') AND (reader = '0') THEN
			quitter := '0';
			block_prog := '1';
			prog_suspend := "11";
			new_state := 12;
		ELSIF (ceb = '1') THEN
			holder2 := '1';
			new_state := 6;
		ELSIF (oeb = '0') AND (ceb = '0') 
		AND (web = '1') AND (reader = '0')
		AND (quitter = '0') THEN		-- Output Status Register
			FOR j IN 0 TO statreg'LENGTH - 1 LOOP
				tempdata(j) := statreg(j);
			END LOOP;
			FOR j IN 8 TO dq'LENGTH -1 LOOP
				tempdata(j) := '0';
			END LOOP;
			dq <= tempdata AFTER tGLQV;
			new_state := 11;
		ELSIF (web = '0') AND (oeb = '1') THEN
			IF (dq = "0000000011111111") THEN	-- FFh
				reader := '1';
				new_state := 11;
			ELSIF (dq = "0000000000010000") 
			OR (dq = "0000000001000000") THEN	-- 10h OR 40h
			  	ASSERT (add'LAST_EVENT >= tAVWH)
			  	REPORT "Address Setup Time Violation."				
			  	SEVERITY ERROR;
				place_holder := '1';
				timer1 := NOW;
				new_state := 3;
			ELSIF (dq = "0000000011010000") THEN	-- D0h
				reader := '0';
				quitter := '1';
				new_state := 11;
			ELSIF (dq = "0000000001110000") THEN	-- 70h
				new_state := 11;
			ELSE
				ASSERT ((dq = "0000000011111111") OR (dq = "0000000011010000"))
				REPORT "Invalid Command Code!"
				SEVERITY ERROR;
				new_state := 11;
			END IF;
		ELSIF (web = '1') AND (reader = '1') AND (oeb = '0') AND (quitter = '0') THEN
			ASSERT (dq'LAST_EVENT >= tWHDX)
			REPORT "Data Hold Time Violation."
			SEVERITY ERROR;
			ASSERT (add'LAST_EVENT >= tAVWH) 
			REPORT "Address Setup Error."
			SEVERITY ERROR;
			adder := 0;
			twosum := 1;
			FOR i IN 0 TO add'LENGTH - 1 LOOP
				IF (add(i) = '1') THEN
			       		adder := adder + twosum;
		       		END IF;
			       	twosum := twosum * 2;
			END LOOP;
		 	FOR j IN 0 TO memory(adder)'LENGTH - 1 LOOP
		 		dq(j) <= memory(adder) (j);
		 	END LOOP;
			new_state := 11;
		ELSIF (rpb = '0') THEN
			new_state := 10;	--Goes to Powerdown
		ELSE
			new_state := 11;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 12 =>			-- Block Erase Check
		state := 12;
		
		IF (counter2 = interupt) THEN
			prog_suspend := "11";
			counter2 := 0;
			interupt_check2 := '1';
			new_state := 7;
		ELSIF (write_type = "10") AND (web = '0') AND (dq = "0000000010110000") THEN
			prog_suspend := "01";
			block_prog := '0';
			new_state := 3;
		ELSE
			counter2 := counter2 + 1;
			new_state := 12;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;

	WHEN 14 =>			-- Program Interupt Check
		state := 14;
		
		IF (counter1 = interupt) THEN
			prog_suspend := "11";
			counter1 := 0;
			interupt_check1 := '1';
			new_state := 7;
		ELSIF (write_type = "01") AND (web = '0') AND (dq = "0000000010110000") THEN
			prog_suspend := "00";
			prog := '0';
			new_state := 3;
		ELSE
			counter1 := counter1 + 1;
			new_state := 14;
		END IF;

		state_clock := NOT state_clock;
	 	clock <= state_clock after 0.5 ns;


	WHEN OTHERS =>

END CASE;

END PROCESS MAIN;

EL_GUAPO:PROCESS

BEGIN

	WAIT ON clock;
	   	next_clock <= not next_clock after 0.5 ns;
	
END PROCESS EL_GUAPO;

END behavior;
