--INTEL DEVELOPER'S SOFTWARE LICENSE AGREEMENT

--BY USING THIS SOFTWARE, YOU ARE AGREEING TO BE BOUND 
--BY THE TERMS OF THIS AGREEMENT.  DO NOT USE THE SOFTWARE 
--UNTIL YOU HAVE CAREFULLY READ AND AGREED TO THE FOLLOWING 
--TERMS AND CONDITIONS.  IF YOU DO NOT AGREE TO THE TERMS 
--OF THIS AGREEMENT, PROMPTLY RETURN THE SOFTWARE PACKAGE 
--AND ANY ACCOMPANYING ITEMS.

--IF YOU USE THIS SOFTWARE, YOU WILL BE BOUND BY THE TERMS 
--OF THIS AGREEMENT.

--LICENSE:  Intel Corporation ("Intel") grants you 
--the non-exclusive right to use the enclosed software 
--program ("Software").  You will not use, copy, modify, 
--display, rent, sell or transfer the Software or any portion 
--thereof, except as provided in this Agreement.

--System OEM Developers may:
--1.      copy the Software for internal support, backup 
--        or archival purposes;
--2.      internally install, use, display, or distribute 
--        Intel owned Software in object code format;
--3.      internally modify Software source code that 
--        Intel makes available to you for internal use 
--        only as an OEM Developer;
--4.	internally install, use, display, modify, distribute, 
--        and/or make derivatives ("Derivatives") of Intel owned 
--        Software ONLY if you are a System OEM Developer and  
--        NOT an end-user.

--RESTRICTIONS:

--YOU WILL NOT:
--1.  	copy the Software, in whole or in part, except as 
--        provided for in this Agreement;
--2.      decompile or reverse engineer any Software provided 
--        in object code format;
--3.      distribute any Software or Derivative code to any 
--        end-users, unless approved by Intel in a prior writing.

--TRANSFER: You may not transfer the Software to any third 
--party without Intels prior written consent.

--OWNERSHIP AND COPYRIGHT OF SOFTWARE: Title to the Software 
--and all copies thereof remain with Intel or its vendors.  
--The Software is copyrighted and is protected by United States
--and international copyright laws.  You will not remove the 
--copyright notice from the Software.  You agree to prevent 
--any unauthorized copying of the Software.

--DERIVATIVE WORK: OEM Developers that make Derivatives will 
--not be required to provide Intel with a copy of the source 
--or object code.  Any modification of Software shall be at 
--your sole risk and expense. No Software or Derivative 
--distribution to any third party is permitted under this 
--Agreement.

--DUAL MEDIA SOFTWARE: If the Software package contains 
--multiple media, you may only use the medium appropriate 
--for your system.
 
--WARRANTY: Intel warrants that it has the right to license 
--you to use, modify, display, or distribute the Software as 
--provided in this Agreement. The Software is provided "AS IS" 
--without WARRANTY of any kind.  Intel makes no representations 
--to upgrade, maintain, or support the Software at any time.


--THE ABOVE WARRANTIES ARE THE ONLY WARRANTIES OF ANY  
--KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WARRANTIES 
--OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE 
--OR INFRINGEMENT OF ANY PATENT, COPYRIGHT OR OTHER 
--INTELLECTUAL PROPERTY RIGHT.

--LIMITATION OF LIABILITY: NEITHER INTEL NOR ITS 
--VENDORS OR AGENTS SHALL BE LIABLE FOR ANY LOSS 
--OF PROFITS, LOSS OF USE, LOSS OF DATA, INTERRUPTION 
--OF BUSINESS, NOR FOR INDIRECT, SPECIAL, INCIDENTAL 
--OR CONSEQUENTIAL DAMAGES OF ANY KIND WHETHER UNDER 
--THIS AGREEMENT OR OTHERWISE, EVEN IF ADVISED OF THE 
--POSSIBILITY OF SUCH DAMAGES.

--TERMINATION OF THIS LICENSE: Intel reserves the right 
--to conduct or have conducted audits to verify your 
--compliance with this Agreement.  Intel may terminate 
--this Agreement at any time if you are in breach of 
--any of its terms and conditions.  Upon termination, 
--you will immediately destroy, and certify in writing 
--the destruction of, the Software or return all copies 
--of the Software and documentation to Intel.

--U.S. GOVERNMENT RESTRICTED RIGHTS: The Software and 
--documentation were developed at private expense and 
--are provided with "RESTRICTED RIGHTS".  Use, duplication 
--or disclosure by the Government is subject to restrictions 
--as set forth in FAR52.227-14 and DFAR252.227-7013 et seq. 
--or its successor.

--EXPORT LAWS: You agree that the distribution and 
--export/re-export of the Software is in compliance 
--with the laws, regulations, orders or other restrictions 
--of the U.S. Export Administration Regulations.

--APPLICABLE LAW: This Agreement is governed by the 
--laws of the State of California and the United States, 
--including patent and copyright laws.  Any claim 
--arising out of this Agreement will be brought in 
--Santa Clara County, California.


-- Specifics For Type2 Package File

-- 150ns 28FXXXB3 Part
-- Both Vcc & Vccq are intialized to 3.3 Volts
-- Vpp = 2.7 Volts


LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE type1_pkg IS


TYPE voltage IS RANGE 0 TO 13000000
	UNITS
		uV;    		-- micro Volts
		mV = 1000 uV; 	-- milli Volts
		V = 1000 mV;	-- Volts
	END UNITS;

-- The following ia a constants lists of timings for the 
-- 28FXXXB3 150ns product.

-- Read Operation Times

	CONSTANT	tAVAV	:TIME:=150 ns;
	CONSTANT	tAVQV	:TIME:=150 ns;
	CONSTANT	tELQV	:TIME:=150 ns;
	CONSTANT	tPHQV	:TIME:=600 ns;
	CONSTANT	tGLQV	:TIME:=65 ns;
	CONSTANT	tELQX	:TIME:=0 ns;
	CONSTANT	tEHQZ	:TIME:=55 ns;
	CONSTANT	tGLQX	:TIME:=0 ns;
	CONSTANT	tGHQZ	:TIME:=45 ns;
	CONSTANT	tOH	:TIME:=0 ns;
	CONSTANT	tELOL	:TIME:=85 ns;	-- Calculated using tELQV - tGLQV

-- Write Operation Times

	CONSTANT	tPHWL	:TIME:=600 ns;
	CONSTANT	tPHEL	:TIME:=600 ns;
	CONSTANT	tELWL	:TIME:=0 ns;
	CONSTANT	tWLEL	:TIME:=0 ns;
	CONSTANT	tWLWH	:TIME:=90 ns;
	CONSTANT	tELEH	:TIME:=90 ns;
	CONSTANT	tDVWH	:TIME:=70 ns;
	CONSTANT	tDVEH	:TIME:=70 ns;
	CONSTANT	tAVWH	:TIME:=90 ns;
	CONSTANT	tAVEH	:TIME:=90 ns;
	CONSTANT	tWHEH	:TIME:=0 ns;
	CONSTANT	tEHWH	:TIME:=0 ns;
	CONSTANT	tWHDX	:TIME:=0 ns;
	CONSTANT	tEHDX	:TIME:=0 ns;
	CONSTANT	tWHAX	:TIME:=0 ns;
	CONSTANT	tEHAX	:TIME:=0 ns;
	CONSTANT	tWHWL	:TIME:=30 ns;
	CONSTANT	tEHEL	:TIME:=30 ns;
	CONSTANT	tVPWH	:TIME:=200 ns;
	CONSTANT	tVPEH	:TIME:=200 ns;
	CONSTANT	tQVVL	:TIME:=0 ns;
	CONSTANT	tLOCK	:TIME:=200 ns;

-- Erase/Program Timings (Typical Timings @ Vpp = 2.7 V)

	CONSTANT	tBWPB	:TIME:=100 ms;
	CONSTANT	tBWMB	:TIME:=800 ms;
	CONSTANT	tWHQV1	:TIME:=100 ns; -- * Note1
	CONSTANT	tEHQV1	:TIME:=100 ns; -- * Note1
	CONSTANT	tWHQV2	:TIME:=100 ns; -- * Note1
	CONSTANT	tEHQV2	:TIME:=100 ns; -- * Note1
	CONSTANT	tWHQV3	:TIME:=100 ns; -- * Note1
	CONSTANT	tEHQV3	:TIME:=100 ns; -- * Note1
	CONSTANT	tWHRH1	:TIME:=6 us;
	CONSTANT	tEHRH1	:TIME:=6 us;
	CONSTANT	tWHRH2	:TIME:=13 us;
	CONSTANT	tEHRH2	:TIME:=13 us;

-- ********************* Note1 *****************************

-- These values were changed to 100 ns for simulation purposes.
-- This was done due to constraints on simulator memory.  Timings 
-- over 10 us long contain too many data points to be stored in memory.
-- The actual values for these timings can be found below.

--	CONSTANT	tWHQV1	:TIME:=22 us;
--	CONSTANT	tEHQV1	:TIME:=22 us;
--	CONSTANT	tWHQV2	:TIME:=1000 ms;
--	CONSTANT	tEHQV2	:TIME:=1000 ms;
--	CONSTANT	tWHQV3	:TIME:=1800 ms;
--	CONSTANT	tEHQV3	:TIME:=1800 ms;

-- ***********************************************************

-- Input Voltage Pins Settings

	CONSTANT	vcc_voltage :voltage := 3.3 V;
	CONSTANT	vpp_voltage :voltage := 2.7 V;
	CONSTANT	vccq_voltage :voltage := 3.3 V;
	
END type1_pkg;